/*
 * Copyright (C) 2020, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef CPUSHBUTTON_H
#define CPUSHBUTTON_H

#include <QObject>
#include <QPushButton>
#include <QVariant>

class CPushButtonEx : public QPushButton
{
    Q_OBJECT

public:
    explicit CPushButtonEx(QWidget *parent = 0);
    ~CPushButtonEx();

public:
    QVariant Data() { return m_varData; }
    void SetData(QVariant varData) { m_varData = varData; }
    void SetExArea(bool bExArea) { m_bExArea = bExArea; }
    void SetAspectRatio(double fRadio) { m_bRadio = true; m_fRadio = fRadio; }

protected:
    void mouseReleaseEvent(QMouseEvent *e);
    void resizeEvent(QResizeEvent *event);

signals:
    void SignalClicked();               // 点击正常区域
    void SignalClickedExArea();        // 点击扩展区域

private:
    QVariant m_varData;
    bool m_bExArea;
    bool m_bRadio;
    double m_fRadio;
};

#endif // CPUSHBUTTON_H
